//---------------------------------------------------------------------------
#ifndef ObjectFileH
#define ObjectFileH
//---------------------------------------------------------------------------

#include <stdio.h>
#include "Assembler.h"
#include "SymTable.h"

class CObjectFile
{
  public:
    CObjectFile() {};
    ~CObjectFile() {}
    void New();
    void OutputByte(const char c);
    void OutputInstr();
    void AddLocal();
    void AddLocalAddr(int addr); 
    void AddExt(const char *c);
    bool Write(const char *fname, CSymTable &sym);
    void Dump();

  private:
    void fputw(int c, FILE *fp);

    struct
    {
      int address[MAXADDR],
          addr;
      char name[MAXSYM];
    } _table[MAXEXT];

    struct _LineNum
    {
      int addr,
          line;
    } _linenum[MAXOUTPUT];

    char _output[MAXOUTPUT];
    int _outputsize,
        _reloc,
        _line;
};

extern CObjectFile objectfile;

#endif
