//---------------------------------------------------------------------------
#pragma hdrstop

#include <string.h>
#include "Assembler.h"
#include "Preprocessor.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

bool CPreprocessor::Process(const char *fname, FILE *out, bool f)
{
  FILE *fp;
  char c[65535],
       d[16],
       *p;
  int  l, i, file;

  if (f)
  {
    _files = 0;
    _lines = 0;
    _defines = 0;
  }

  if (_files + 1 == MAXFILES)
  {
    assembler.ErrorI(PPNOFILES, MAXFILES);
    return false;
  }
  for(i = 0; i < _files; i++)
    if (!strcmpi(fname, _file[i]))
    {
      assembler.Error(PPFILEINC, fname);
      return false;
    }
  file = _files;
  strcpy(_file[_files++], fname);
  fp = fopen(fname, "r");
  if (fp == NULL)
  {
    assembler.Error(PPOPEN, fname);
    return false;
  }
  l = 0;
  while (!feof(fp))
  {
    l++;
    *c = '\0';
    fgets(c, sizeof(c), fp);
    if (c[0] == '#')
    {
      i = 1;
      while ((c[i] != ' ') && (c[i] != '\0'))
      {
        d[i - 1] = c[i];
        i++;
      }
      d[i - 1] = '\0';
      if (!strcmpi(d, "include"))
      {
        if (c[i] == '\0')
        {
          assembler.Error(PPFNAMEEXP, "");
          return false;
        }
        i++;
        if ((c[i] == '\"') || (c[i] == '<'))
          i++;
        if ((p = strchr(&c[i], '\"')) != NULL)
          *p = '\0';
        if ((p = strchr(&c[i], '>')) != NULL)
          *p = '\0';
        if (!Process(&c[i], out, false))
          return false;
      }
      else if (!strcmpi(d, "define"))
      {

      }
      else
        assembler.Error(PPUNREQDIR, d);
    }
    else
    {
      if (_lines + 1 == MAXLINES)
      {
        assembler.ErrorI(PPNOLINES, MAXLINES);
        return false;
      }
      if (strchr(c, '\n') == NULL)
        strcat(c, "\n");
      fputs(c, out);
      _line[_lines].line = l;
      _line[_lines].file = file;
      _lines++;
    }
  }
  fclose(fp);

  return (!assembler.Errors());
}

char *CPreprocessor::FileName(int l)
{
  return _file[_line[l - 1].file];
}

int CPreprocessor::LineNum(int l)
{
  return _line[l - 1].line;
}

void CPreprocessor::AddDef(char *n, char *d)
{
  if (_defines == MAXDEFS)
  {
    assembler.ErrorI(PPDEFFULL, MAXDEFS);  
    return;
  }

  strcpy(_define[_defines].name, n);
  strcpy(_define[_defines].def, d);
  _defines++;
}

void CPreprocessor::DeleteDef(char *n)
{
  int i;

  for(i = 0; i < _defines; i++)
    if (!strcmpi(n, _define[i].name))
    {
      _defines--;
      strcpy(_define[i].name, _define[_defines].name);
      strcpy(_define[i].def, _define[_defines].def);
      return;
    }
}

bool CPreprocessor::DefExists(char *n)
{
  int i;

  for(i = 0; i < _defines; i++)
    if (!strcmpi(n, _define[i].name))
      return true;

  return false;
}

