//---------------------------------------------------------------------------
#ifndef SymTableH
#define SymTableH
//---------------------------------------------------------------------------

#include "AsmDefs.h"

class CSymTable
{
  public:
    CSymTable();
    ~CSymTable() {};
    void Add(const char *n, int v, bool e,
              bool local, bool p, const char *r);
    int  Get(const char *n);
    char *GetExt(const char *n);
    bool Exists(const char *n);
    void Dump();
    bool External(const char *n);
    bool Local(const char *n);
    int  FirstLocal();
    bool NextLocal(char *n, int &v);
    void BeginGet();
    bool NextGet(char *n, int &v);

  protected:
    int Find(const char *n);
    int FindL(int n);

    struct _SymEntry
    {
      char name[MAXSYM];
      int  value;
      int  line;
      bool external;
      bool local;
      bool exp;
      int  extref;
    };

    struct _SymEntry *_table;
    int _entries,
        _currlocal,
        _currget;
};

#endif
