//---------------------------------------------------------------------------
#ifndef LinkH
#define LinkH
//---------------------------------------------------------------------------

#include <stdio.h>
#include "AsmDefs.h"

enum {MAXOBJ = 256, MAXBANKS = 128, BANKSIZE = 16384,
      MAXOSYM = 65535};

class CLink
{
  public:
    CLink() {}
    ~CLink() {}
    bool Link(const char *gb, char *fname[], int fnames);

  private:
    void Error(const char *m, const char *s);
    void Message(const char *m, const char *s);
    void ReadObjectFile(FILE *fp);
    void Dump();
    void Write(FILE *fp);
    int  AddPage(int n, char *o, int s, int p);
    void AddSym(const char *c, int v, int p);
    int  GetSym(const char *c);
    int  fgetw(FILE *fp);
    void AddWord(char *b, int a);

    struct _SymEnt
    {
      int address[MAXADDR],
          addr;
      char name[MAXSYM];
    };

    struct _LSymEnt
    {
      char name[MAXSYM];
      int   addr,
           page;
    };

    struct _LineNum
    {
      int addr,
          line,
          page;
    };

    struct _Obj
    {
      char     output[MAXOUTPUT],
               fname[256];
      _SymEnt  loc,
               ext[MAXEXT];
      _LSymEnt lsym[MAXSYMENT];
      _LineNum linenum[MAXOUTPUT];
      int      outputsize,
               extsize,
               lsymsize,
               linenums,
               addr,
               page;
    };

    _Obj     *_obj[MAXOBJ];
    _LSymEnt *_sym;
    int      _objs,
             _symnum;
    bool     error;
};
#endif
